﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data;
using SDRSharp.Common;
using SDRSharp.Radio;

namespace SDRSharp.Trunker
{
    public unsafe class TrunkerPlugin : ISharpPlugin, IAudioProcessor
    {
        private const string _displayName = "Trunker";
        private ISharpControl _controlInterface;
        private TrunkerPanel _trunkerPanel;
        private double _sampleRate;

        private bool _bypass = true;

        public bool Bypass
        {
            get { return _bypass; }
            set { _bypass = value; }
        }

        public bool HasGui
        {
            get { return true; }
        }

        public UserControl GuiControl
        {
            get { return _trunkerPanel; }
        }

        public string DisplayName
        {
            get { return _displayName; }
        }

        public void Initialize(ISharpControl control)
        {
            _controlInterface = control;
            _trunkerPanel = new TrunkerPanel(_controlInterface,this);
            _controlInterface.RegisterStreamHook(this);
        }

        public double SampleRate
        {
            get { return _sampleRate; }
            set { _sampleRate = value; }
        }

        public void Process(float* audioBuffer, int length)
        {
            if (!_bypass)
            {
                _trunkerPanel.MuteBeeps(audioBuffer, length);
            }
        }

        public void Close()
        {
        }
    }
}